#!/usr/bin/perl
# recognizer through templates v2.2 - min / Tucker 110321

#  :
use GD;
use Image::Magick;	#      

my $debug=0;		# 1 -   ,    ,    
my $extract=0;		#  ,    1-7
my $image=$ARGV[0]; #   : JPEG
					#    ,         ( )
if ($image!~/\.jpg$/i) { print "File format error\n"; exit; }

my $recresult="";	#     
my $myImage = newFromJpeg GD::Image($image);	#  
my $wh_sens=80;	#   , R>70 & G>70 & B>70 = White
				#   ,      
				#        
				#          

my ($img_wdt,$img_hgt)=$myImage->getBounds;	#   ,  640+
my $blk_hgt=50/320*$img_wdt;				#     (50    320)
my $blk_top=0;								#    ,   0 ( )
my $let_wdt=0;								#  ,  
my $let_hgt;								# 
my $symcount=0;								# -  
my $sx,$sy;									#     (  )

for $x(0..$img_wdt) {						#  ,       X-
my @col;									#   
for $y($blk_top..$blk_hgt) {				#     Y-,  -   
	$index = $myImage->getPixel($x,$y); 	
	($r,$g,$b) = $myImage->rgb($index); 
	$white=0; $val=0;
	if ( ( $r>$wh_sens )&&( $g>$wh_sens )&&( $b>$wh_sens ) ) { $white=1; $val=1; } # !  
	if (!$x && $white) { $blk_hgt=$y-1; $blk_top=0; last; }	#     X   
	push(@col,$val);
}											#  

 my $zzz=@col;
 for ($i=($zzz-1);$i>=($zzz-15);$i--) { #      ,     
  if ($col[$i]) { pop(@col); }			#  
  else { last; }
 }

my $sum=0;
$sum += $_ for @col;					#  -    
if ($sum) { 							#  - ,     $sx,    $x
	if ($let_wdt==0) { $sx=$x; }
	my $gr=join("",@col); $gr=~s/0/ /g; $gr=~s/1/X/g;
	print "$x $sum\t: $gr :$let_wdt\n" if ($debug);		#     ( )
	$let_wdt++;							#  
	if (($x-$sx)>(13/320*$img_wdt)) { $sum=0; }	#       ,  
}

if (!$sum && $let_wdt) {				#  ,   
 if ($let_wdt<(6/320*$img_wdt)) { goto SKIPTHIS; }	#    ,  

  #   SY-   EY-  
  my $sy=0,$ey=0;
  my $blk_mid=$blk_top+int(($blk_hgt-$blk_top)/2);	#     -,    
  my $midb,$blk_midb;
  for $blk_midb($blk_mid..$blk_hgt) {				# 
   $val=0;
   for $i($sx..($x-1)) {
	$index = $myImage->getPixel( $i,$blk_midb );
	( $r,$g,$b ) = $myImage->rgb( $index );
    if ( ( $r>$wh_sens )&&( $g>$wh_sens )&&( $b>$wh_sens ) ) { $val++; }
   }
   $midb=$blk_midb;
   if (!$val) { last; }
  }
  $ey=$midb;

  my $midt;
  for ($blk_midb=($blk_mid-1);$blk_midb>=$blk_top;$blk_midb--) {	#  
   $val=0;
   for $i($sx..($x-1)) {
	$index = $myImage->getPixel( $i,$blk_midb );
	( $r,$g,$b ) = $myImage->rgb( $index );
        if ( ( $r>$wh_sens )&&( $g>$wh_sens )&&( $b>$wh_sens ) ) { $val++; }	#      
   }
   $midt=$blk_midb;
   if (!$val) { last; }
  }
  $sy=$midt+1;

####  print -   
if ($debug) {
  print "Symbol detected:\n";
  for $j($sy..($ey-1)) {
   for $i($sx..($x-1)) {
	$index = $myImage->getPixel( $i,$j );
	( $r,$g,$b ) = $myImage->rgb( $index );
        if ( ( $r>$wh_sens )&&( $g>$wh_sens )&&( $b>$wh_sens ) ) {
	 print "X"; 
        } else { 
	 print "_"; 
	}
    }
    print "\n";
   }
}
#### eo print


  $let_hgt=$ey-$sy;		#  
  if ($let_hgt<(14/320*$img_wdt)) { goto SKIPTHIS; }	#   ,   , 
  my $prop=$let_wdt/$let_hgt;							#    ,   ~0,50
  print "\nX: $sx-$x Y: $sy-$ey Cols: $let_wdt Rows: ".$let_hgt." Symbol: $symcount\n" if $debug;
  $symcount++;

  #  ,        
  #     ,   
  my @ident_mas = (0,0,0,0,0,0,0,0,0,0);		#     0..9
  my $num_index = 0;
  for $dig(0..9) {								#   
   $#template_pic=-1;							#  ,   
   for $ccc(10..20) {							# -     (  )
    $fnn="./digtemprec/t".$dig."_".$ccc.".png";
    if (-e $fnn) { push(@template_pic,$fnn); }
   }

  foreach  my $template ( @template_pic ) {		#   
    my $tmp_image_bas = newFromPng GD::Image( $template ) || next;  #    newFromJpeg
	#      ,      
	#        (        - )
	my $tmp_image=GD::Image->new($let_wdt,$let_hgt);
	my ($tx,$ty)=$tmp_image_bas->getBounds;
	$tsy=0;	#    ,  :  
	$crp="";
	if ($let_hgt<40/640*$img_wdt) { #      ( )
		$tyc=int($ty*(0.5/$prop));	#   ,  
		if ($ey>($blk_hgt-16-20)/640*$img_wdt) { #     ? 16          640,  20   
			$tsy=0; $ty=$tyc; $crp="*bot $prop";
		}
		else {		# top cropped
			$tsy=$ty-$tyc; $ty=$tyc; $crp="*top $prop";
		}
	}
	$tmp_image->copyResized($tmp_image_bas,0,0,0,$tsy,$let_wdt,$let_hgt,$tx,$ty);	#   
	#$tmp_image->copyResampled   #srcf,dstx,y,srcx,y,dstw,h,srcw,h		#    JPEG  ....
	print "$let_hgt/$ey RRR: $tsy,$let_wdt,$let_hgt,$tx,$ty $crp\n" if ($debug);

  #      
  my $crcs=0;
  for $j($sy..($ey-1)) {
   my $bitl1="",$bitl2="";
   for $i($sx..($x-1)) {
	$index = $myImage->getPixel( $i,$j );
	( $r1,$g1,$b1 ) = $myImage->rgb( $index );
        if ( ( $r1>$wh_sens )&&( $g1>$wh_sens )&&( $b1>$wh_sens ) ) { $bitl1.='1'; } else { $bitl1.='0'; }
       $pixel = $tmp_image->getPixel($i-$sx, $j-$sy); 
        ($r2, $g2, $b2) = $tmp_image->rgb($pixel); 
        if ( ( $r2>$wh_sens )&&( $g2>$wh_sens )&&( $b2>$wh_sens ) ) { $bitl2.='1'; } else { $bitl2.='0'; }
   }
   $bitl1n=oct("0b1".$bitl1); $bitl2n=oct("0b0".$bitl2);
   $xorr=$bitl1n ^ $bitl2n; 	#        $crcs
   $xorrp=sprintf "%#bn",$xorr; $xorrp=~s/^0b1//;$xorrp=~s/n$//;
   @sumx=split(//,$xorrp); my $tot=0; ($tot+=$_) for @sumx;
   $crcs+=$tot;
   print "$bitl1 $bitl2 : $xorrp   $crcs\n" if $debug;	#   :    
  }
  $crce=1000000/(1+$crcs*$crcs); $ident_mas[$num_index]+=$crce;	#    
  print "----$template---($sx..$x)-($sy..$ey)--\n" if $debug;
  } #     

 $num_index++;
 } #  

		 #   
         my $max = $ident_mas[0]; 
         my $max_id = 0;
         for (my $k2 = 1; $k2 < 10; $k2++) { 
            if ($max < $ident_mas[$k2]) { $max = $ident_mas[$k2]; $max_id = $k2; } 
         } 

    print "\n================ Result symbol N$symcount: ".$max_id."\n\n" if $debug;
	$recresult.=$max_id;	#   
	if ($symcount==5) { $recresult.=","; }


#---   :       
# 	            
 if ($extract && $symcount>=$extract) {
  print "\n-- Extract: $symcount symbol, is it: $max_id ?\n";
  for $j($sy..($ey-1)) {
   my $bitl1="";
   for $i($sx..($x-1)) {
	$index = $myImage->getPixel( $i,$j );
	( $r1,$g1,$b1 ) = $myImage->rgb( $index );
        if ( ( $r1>$wh_sens )&&( $g1>$wh_sens )&&( $b1>$wh_sens ) ) { $bitl1.='1'; } else { $bitl1.='0'; }
   }
   print $bitl1."\n";
  }

  my $oImageMagick = Image::Magick->new;
  $oImageMagick->Read($image);
  $oImageMagick->Crop(x=>$sx, y=>$sy);			#   SX,SY  X,EY -  
  $oImageMagick->Crop(width=>$x, height=>$ey);
  print "Save file? [0-9]: "; $fn=<STDIN>; chomp($fn);
  if ($fn=~/\d/) {
   my $tmpf="./digtemprec/tmp.png";
   $oImageMagick->Write($tmpf);
   my @filedata=stat($tmpf); my $tmpfs=$filedata[7];
   for (10..20) {
	$fnn="./digtemprec/"."t".$fn."_".$_.".png";
	if (-e $fnn) {
		@filedata=stat($fnn);  # [7]=filesize	      
		if ($tmpfs==$filedata[7]) { print "Same size: $fnn ;not saved\n"; last; }
		} else {
			my $winf="$tmpf $fnn";
			$winf=~s/\//\\/g;	#   Windows
			`copy $winf`;		#   Windows,   cp  Unix
			print "FILE SAVED: $fnn\n";
			last;
		}
    }
   }
  }
#--- eo extract


SKIPTHIS:	#  
 $let_wdt=0;
 $sx=0; $sy=0;
 if ($symcount==7) { last; }

}

}

print "\nRECOGNITION RESULT: ".$recresult."\n";
exit;

